package com.wily.introscope.typeviews.datadriven.sdk;

import com.wily.introscope.console.thornhill.manager.IThornhillItem;
import com.wily.introscope.console.thornhill.manager.agent.ThornhillAgent;
import com.wily.introscope.console.thornhill.manager.agent.ThornhillMetricPath;
import com.wily.introscope.console.thornhill.ui.ThornhillUserInterface;
import com.wily.introscope.console.thornhill.ui.IUserInterfaceServices;
import com.wily.introscope.console.thornhill.ui.typeviewer.ATypeViewer;
import com.wily.introscope.console.thornhill.ui.typeviewer.ITypeViewerFactory;
import com.wily.introscope.console.thornhill.ui.typeviewer.util.TypeViewerHelper;
import com.wily.introscope.console.thornhill.ui.util.HistoricalRangeStatusPanel;
import com.wily.introscope.console.thornhill.ui.util.IHistoricalRangeStatusBar;
import com.wily.introscope.console.thornhill.ui.util.IHistoricalRangeStatusPanel;
import com.wily.introscope.ext.common.typeviews.datadriven.IDataDrivenRepositoryService;
import com.wily.introscope.ext.common.typeviews.datadriven.XMLCarrier;
import com.wily.introscope.ext.workstation.typeviews.datadriven.*;
import com.wily.introscope.util.HistoricalQueryRange;
import com.wily.isengard.messageprimitives.ConnectionException;
import com.wily.isengard.messageprimitives.service.MessageServiceFactory;
import com.wily.util.feedback.IModuleFeedbackChannel;
import com.wily.util.feedback.Module;
import com.wily.ui.IGenericServices;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileSystemView;



public class SDKTypeViewerCustom extends ATypeViewer implements IHistoricalRangeStatusBar

{
	 	private TypeViewerHelper fHelper;
	    private File fXMLFile;
	    private HistoricalRangeStatusPanel fStatusBar;
	    private ThornhillUserInterface fThornhillUserInterface;
	    private ITypeViewerFactory fITypeViewerFactory[];
	    private Runnable fRunnableTypeViewer;
	    private Runnable fFilePoller;
	    private JComponent fHeaderPanel;
	    private IDataDrivenRepositoryService fIDataDrivenRepositoryService;
	    private JButton fOpenFileButton;
	    private JButton fOpenDistantFileButton;
	    private JButton fReloadDistantFileButton;
	    private JButton fNewFileButton;
	    private JLabel fFileNameLabel;
	    private JPanel fCenterPanel;
	    private DataDrivenTypeViewer fTypeViewers[];
	    private IThornhillItem fSelectedItem;
	    private HistoricalQueryRange fHistoricalRange;
	    private String fSelectedTypeViewID;
	    private long fLastFileReloadTime;
	    private final JPanel fComponent;
	    private XMLCarrier fXMLCarrier;
	    private JLabel SDKName;
	    public static float kTabOrder = 200F;
	    private final IModuleFeedbackChannel fSimpleFeedbackModule;
	    private Module sModule = new Module("SDKTypeViewerCustom");
	    private String fNameLabel;
	    private String fCarrierFileName;
	    private final GlobalXMLElementMap fElementMap = new GlobalXMLElementMap();
	
	
	 public String getName()
	    {
		 return new String("SDK TypeViewer");
	    }
	 public boolean isEnabled()
	    {
	        return true;
	    }
	 
	 public synchronized void reset()
	    {
		 fSelectedItem = null;
		 resetTypeViewers();
		 fComponent.removeAll();
	   
	    }
	 public IHistoricalRangeStatusPanel getStatusPanel()
	    {
	        return fStatusBar;
	    }
    private class FilePoller
        implements Runnable
    {

        public void run()
        {
            try
            {
                Thread.sleep(1000L);
                reloadFromFile();
            	fFilePoller = new FilePoller();
                fHelper.executeAsync(fFilePoller);
               
            }
            catch(InterruptedException interruptedexception1) { 
            	
            }
            catch(NullPointerException e)
            {
            	// when stopping
            }
        }

        private FilePoller()
        {
            super();
        }

    }

    private static class XMLFileFilter extends FileFilter
    {

        public boolean accept(File file)
        {
            return file.getName().endsWith(".xml") || file.isDirectory();
        }

        public String getDescription()
        {
            return "Type Viewer XML Files";
        }

        private XMLFileFilter()
        {
        }

    }
   
    
    
    public SDKTypeViewerCustom(IUserInterfaceServices uiServices, IGenericServices genericServices)
    {
    	
    	
    	super.initialize(uiServices,genericServices);
    	// fComponent main Panel
    	fComponent = new JPanel();
        fHelper = getTypeViewerHelper();
       	fThornhillUserInterface= (ThornhillUserInterface)uiServices;
        fSimpleFeedbackModule = fThornhillUserInterface.getMainPO().getFeedbackChannel();
        fSimpleFeedbackModule.info(sModule,"Initialisation");
        try
        {
        fStatusBar = new HistoricalRangeStatusPanel(fHelper.getGenericServices());
        // Button reloadDistantFile creation with listener
        fReloadDistantFileButton = new JButton("Reload an EM XML File...");
        fReloadDistantFileButton.addActionListener(new ActionListener()
        {
        	
            public void actionPerformed(ActionEvent actionevent)
            {
            	loadXMLCarrier();
            }
        }
);
        // Button openDistantFile creation with listener
        fOpenDistantFileButton = new JButton("Select an EM XML File...");
        fOpenDistantFileButton.addActionListener(new ActionListener() 
        {
        	
            public void actionPerformed(ActionEvent actionevent)
            {
                openDistantFile();
            }
        }
);
        // Button openFile creation with listener
        fOpenFileButton = new JButton("Select a local XML File...");
        fOpenFileButton.addActionListener(new ActionListener() 
        {
        	
            public void actionPerformed(ActionEvent actionevent)
            {
                openFile();
            }
        }
);
        // Button newFile creation with listener
        fNewFileButton = new JButton("Create New XML File...");
        fNewFileButton.addActionListener(new ActionListener() 
        {
        	public void actionPerformed(ActionEvent actionevent)
            {
                newFile();
            }
        }
);
        fFileNameLabel = new JLabel("No file selected");
        fCenterPanel = new JPanel(new GridLayout(1, 1));
        fTypeViewers = new DataDrivenTypeViewer[0];
        fComponent.setLayout(new BorderLayout());
        }
        catch (Exception e)
        {
        	fSimpleFeedbackModule.error(sModule,e.getMessage());
        	fSimpleFeedbackModule.debug(e);
        }
       
    }
    
    public Component getComponent()
    {
    	 return fComponent;
    }

 
 
    private JComponent getHeaderPanel()
    {
    	if (fHeaderPanel == null)
    	{
	        fHeaderPanel = new JPanel();
	        fHeaderPanel.setOpaque(true);
	        fHeaderPanel.setBackground(new Color(255, 255, 225));
	        SDKName = new JLabel();
	        SDKName.setText("SDK Viewer Information : Local File is pooled every seconds");
	        GridBagLayout topLayout = new GridBagLayout();
	        GridBagConstraints c = new GridBagConstraints();
	        fHeaderPanel.setLayout(topLayout);
	        c.gridx = 0;
	        c.gridy = 0;
	        c.weightx = 1.0D;
	        c.weighty = 0.0D;
	        c.insets = new Insets(5, 3, 5, 3);
	        fHeaderPanel.add(SDKName, c);
    	}
    	
        return fHeaderPanel;
    }

    public void displayItem(IThornhillItem ithornhillitem, HistoricalQueryRange historicalqueryrange)
        throws ConnectionException
    {
    	
    	try
        {
    	fSimpleFeedbackModule.debug(sModule,"displayItem fComponent="+fComponent.toString());
        fComponent.removeAll();
        if (fTypeViewers == null)
        	fTypeViewers = new DataDrivenTypeViewer[0];
        fSelectedItem = ithornhillitem;
        fHistoricalRange = historicalqueryrange;
        fComponent.setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();
        c.gridx = 0;
        c.gridy = 0;
        c.weightx = 1.0D;
        c.weighty = 0.0D;
        c.fill = GridBagConstraints.BOTH;
        c.anchor=GridBagConstraints.NORTH;
        fComponent.add(new JSeparator(), c);
        c.gridy = 1;
        fComponent.add(getHeaderPanel(), c);
        c.gridy = 2;
        fComponent.add(new JSeparator(), c);
        c.gridy = 3;
        JPanel jpanel = new JPanel();
        jpanel.setBorder(BorderFactory.createEtchedBorder());
        jpanel.setLayout(new GridBagLayout());
        jpanel.add(fOpenDistantFileButton);
        jpanel.add(fReloadDistantFileButton);
        jpanel.add(fOpenFileButton);
        jpanel.add(fNewFileButton);
        jpanel.add(fFileNameLabel);
        fComponent.add(jpanel, c);
        c.gridy = 4;
        c.weighty = 1.0D;
        fComponent.add(fCenterPanel, c);
        updateCenterContent();
        fHelper.executeAsync(new FilePoller());
        }
        catch(InterruptedException interruptedexception) { }
        catch(Exception e)
        { e.printStackTrace();
        	fSimpleFeedbackModule.error(e.getMessage());
        	fSimpleFeedbackModule.debug(e);
        }
    }

   

  

    public boolean isSupported(IThornhillItem ithornhillitem)
    {
    	
        return (ithornhillitem instanceof ThornhillMetricPath) || (ithornhillitem instanceof ThornhillAgent);
    }

   

    private void resetTypeViewers()
    {
    
        for(int i = 0; i < fTypeViewers.length; i++)
            fTypeViewers[i].reset();

    }

    public void teardown()
    {
      	fSimpleFeedbackModule.debug(sModule,"teardown called");
    	if (fFilePoller != null)
    		fFilePoller = null;
       if (fHelper != null)
       {
    	fHelper.teardown();
    	fHelper = null;
       }
        
      
        if (fITypeViewerFactory != null)
        {
        	for(int i = 0; i < fITypeViewerFactory.length; i++)
            	fThornhillUserInterface.removeTypeViewerFactory(fITypeViewerFactory[i]);
           	fITypeViewerFactory = null;
        }
        if (fTypeViewers != null)
        {
        	teardownTypeViewers();
        	fTypeViewers = null;
        }
        if (fRunnableTypeViewer != null)
        	fRunnableTypeViewer = null;
        if (fIDataDrivenRepositoryService != null)
        	fIDataDrivenRepositoryService = null;
     
    }

    private void teardownTypeViewers()
    {
    	try
    	{
    		
    		for(int i = 0; i < fTypeViewers.length; i++)
    			fTypeViewers[i].teardown();
       	}
    	catch(NullPointerException e)
    	{
    		fSimpleFeedbackModule.error("Error during Reloading File");
            fSimpleFeedbackModule.debug(e);
            JOptionPane.showMessageDialog(fComponent, "Please click OK to reload", "Error during reloading File", JOptionPane.ERROR_MESSAGE);
    	}
    	catch(Exception e)
    	{
    		
    		fSimpleFeedbackModule.error(e.getMessage());
            fSimpleFeedbackModule.debug(e);
            e.printStackTrace();
            JOptionPane.showMessageDialog(fComponent, e.getMessage(), "Error during reloading File", JOptionPane.ERROR_MESSAGE);
    	}
    }

    private synchronized void openFile()
    {
        fXMLFile = null;
      
        JFileChooser jfilechooser = new JFileChooser();
        FileSystemView view = jfilechooser.getFileSystemView();
        fSimpleFeedbackModule.debug(sModule, "View="+view.getDefaultDirectory().getAbsolutePath());
        jfilechooser.setFileFilter(new XMLFileFilter());
        if(jfilechooser.showOpenDialog(fComponent) == 0)
            fXMLFile = jfilechooser.getSelectedFile();
        if (fXMLFile != null)
        {
        fOpenFileButton.setText("Select Another Local File...");
        fLastFileReloadTime = 0L;
        fNameLabel = fXMLFile.getName();
        reloadFromFile();
        }
    }
    
    private synchronized ArrayList<XMLCarrier> getCarriersList()
    {
    	ArrayList<XMLCarrier> carriers = null;
    	  fSimpleFeedbackModule.debug(sModule, "getCarriersList");
    	try
        {
    	     fIDataDrivenRepositoryService = (IDataDrivenRepositoryService)
            	MessageServiceFactory.getServiceSafe(fThornhillUserInterface.getMainPO(), com.wily.introscope.ext.common.typeviews.datadriven.IDataDrivenRepositoryService.class);
            carriers = new ArrayList<XMLCarrier>();
            carriers.addAll((Collection<XMLCarrier>)Arrays.asList(fIDataDrivenRepositoryService.getTypeViewerXML()));
            fSimpleFeedbackModule.debug(sModule, "carriers.size()="+carriers.size());
            
        }
    	catch (Exception e)
    	{
    		fSimpleFeedbackModule.error(e.getMessage());
            fSimpleFeedbackModule.debug(e);
    	}
    	return carriers;
    	
    	
    }
    
    private synchronized void loadXMLCarrier()
    {
    	ByteArrayInputStream bis;
        if (fCarrierFileName == null)
        	return;
        Iterator<XMLCarrier> iterator = getCarriersList().iterator();
        while (iterator.hasNext())
        {
        	 XMLCarrier carrier = iterator.next();
        	 fNameLabel = carrier.getFilename();
             
             if (fCarrierFileName.equals(fNameLabel))
             {
            	 fXMLCarrier = carrier;
            	 fSimpleFeedbackModule.debug(sModule, "XML Carrier "+fNameLabel+" found !");
            	 break;
             }
        }
        
        try
        {
        bis = new ByteArrayInputStream(fXMLCarrier.getXMLBytes());
          
        reloadTypeViewer(bis);
        
        fLastFileReloadTime = System.currentTimeMillis();
        }
        catch (Exception e)
        {
        	fSimpleFeedbackModule.error(e.getMessage());
            fSimpleFeedbackModule.debug(e);
            JOptionPane.showMessageDialog(fComponent, e.getMessage(), "Error reloading File", JOptionPane.ERROR_MESSAGE);
        }
        return;
    }
    // return a string table of XMLCarrier without typeviews
    private Object[] getStringXMLCarrierList()
    {
    	ArrayList<XMLCarrier> arrayList = getCarriersList();
    	// only xmlTypeViewer in ext, not in the jar files, prefix with typeviews
    	Vector<XMLCarrier> filterCarriers = new Vector<XMLCarrier>();
    	for (int i=0;i<arrayList.size();i++)
    	{
    		if (!arrayList.get(i).getFilename().startsWith("typeviews"))
    		{
    			filterCarriers.addElement(arrayList.get(i));
    		}
    	}
     	String[] returnXMLCarrierName = new String[filterCarriers.size()];
    	for (int i=0;i<filterCarriers.size();i++)
    	{
    		returnXMLCarrierName[i] = filterCarriers.get(i).getFilename();
    	}
    	return returnXMLCarrierName;
    }
  
    private synchronized void openDistantFile()
    {
 
        fSimpleFeedbackModule.debug(sModule, "openDistantFile");
    	try
        {
    		
    		fCarrierFileName = null;
    	    Object[] local_XMLCarrierList = getStringXMLCarrierList();
    	    if (local_XMLCarrierList.length>0)
    	    {
    	    	fCarrierFileName = (String)JOptionPane.showInputDialog(
                    fComponent,
                    "Please choose the correct XML File:\n",
                    "XML EM TypeView Choice",
                    JOptionPane.PLAIN_MESSAGE,
                   
                    null,
                    local_XMLCarrierList,
                    (String)local_XMLCarrierList[0]);
    	    }
    		if ((fCarrierFileName == null) || fCarrierFileName.length() == 0) {
    			 JOptionPane.showMessageDialog(fComponent,
                         "There is no correct EM typeviewer XML File !",
                         "Message error",
                         JOptionPane.ERROR_MESSAGE);
    			 fCarrierFileName = null;
    			 return;
    		 }
                
    	  loadXMLCarrier();
    	
           
        }
    	catch(Exception e)
    	{
    		fSimpleFeedbackModule.error(e.getMessage());
            fSimpleFeedbackModule.debug(e);
            JOptionPane.showMessageDialog(fComponent, e.getMessage(), "Error opening file", 0);
           
    	}
        fLastFileReloadTime = System.currentTimeMillis();
        return;

       
    }
    private synchronized void newFile()
    {
        fXMLFile = null;
        JFileChooser jfilechooser = new JFileChooser();
        jfilechooser.setFileFilter(new XMLFileFilter());
        if(jfilechooser.showSaveDialog(fComponent) == 0)
        {
            File file = jfilechooser.getSelectedFile();
            try
            {
                InputStream inputstream = getClass().getClassLoader().getResourceAsStream("com/wily/introscope/typeviews/datadriven/sdk/template.typeviewers.xml");
                FileOutputStream fileoutputstream = new FileOutputStream(file);
                int i;
                while((i = inputstream.read()) >= 0) 
                    fileoutputstream.write(i);
                fileoutputstream.close();
                inputstream.close();
                fXMLFile = file;
                fNameLabel = fXMLFile.getName();
                fLastFileReloadTime = 0L;
                reloadFromFile();
            }
            catch(IOException ioexception)
            {
                JOptionPane.showMessageDialog(fComponent, ioexception.getMessage(), "Error creating file", 0);
            }
        }
    }
    
    private synchronized void reloadTypeViewer(InputStream inputStream)
    {
    	 resetTypeViewers();
         teardownTypeViewers();
         fSimpleFeedbackModule.debug(sModule,"reloadTypeViewer");
        
         try
         {
        	 // false to not validate xml
        	 TypeViewerSet set = new TypeViewerSet(fThornhillUserInterface, fElementMap, false);
        	 fITypeViewerFactory = set.getTypeViewersFromXMLDocument(inputStream);
             fTypeViewers = new DataDrivenTypeViewer[fITypeViewerFactory.length];
	         for(int i = 0; i < fITypeViewerFactory.length; i++)
	             fTypeViewers[i] = (DataDrivenTypeViewer)fITypeViewerFactory[i].getTypeViewer();
	         
	         fRunnableTypeViewer = new RunnableReloadTypeViewer();
	         SwingUtilities.invokeLater(fRunnableTypeViewer);
         }
         catch(IOException e)
         {
             fSimpleFeedbackModule.error(e.getMessage());
             fSimpleFeedbackModule.debug(e);
             JOptionPane.showMessageDialog(fComponent, e.getMessage(), "Error reloading viewer", 0);
         }
         catch (Exception e)
         {
        	 fSimpleFeedbackModule.error(e.getMessage());
             fSimpleFeedbackModule.debug(e);
             JOptionPane.showMessageDialog(fComponent, e.getMessage(), "Error reloading viewer", 0);
       
         }	
         finally
         {
        	 try
        	 {
	        	 inputStream.close();
	        	 for (int i=0;i<fITypeViewerFactory.length;i++)
	        	 {
	        		 fThornhillUserInterface.removeTypeViewerFactory(fITypeViewerFactory[i]);
	        	 }
        	 }
        	 catch (Exception e)
        	 {
        		 fSimpleFeedbackModule.error(e.getMessage());
                 fSimpleFeedbackModule.debug(e);
                 JOptionPane.showMessageDialog(fComponent, e.getMessage(), "Error reloading viewer", 0);
        	 }
         }
         
    }

    private synchronized void reloadFromFile()
    {
    	FileInputStream fileinputstream;
        if(fXMLFile == null)
            return;
        if(fXMLFile.lastModified() < fLastFileReloadTime)
            return;
        fileinputstream = null;
        try
        {
        fileinputstream = new FileInputStream(fXMLFile);
        BufferedInputStream bufferedinputstream = new BufferedInputStream(fileinputstream);
        
        reloadTypeViewer(bufferedinputstream);
        
        fLastFileReloadTime = System.currentTimeMillis();
        }
        catch (FileNotFoundException e)
        {
        	fSimpleFeedbackModule.error(e.getMessage());
            fSimpleFeedbackModule.debug(e);
            JOptionPane.showMessageDialog(fComponent, e.getMessage(), "Error reloading File", 0);
        }
        return;
    }

   
    private synchronized void updateCenterContent()
    {
    	final JTabbedPane tab = new JTabbedPane();
        String s = "No type viewer matches this tree item\nthe specifiers for the type viewers are: \n\n";
        for(int i = 0; i < fTypeViewers.length; i++)
        {
            String s1 = fTypeViewers[i].getName();
            if(fTypeViewers[i].isSupported(fSelectedItem))
            {
                Component component = fTypeViewers[i].getComponent();
                try
                {
                    fTypeViewers[i].displayItem(fSelectedItem, fHistoricalRange);
                    if(!fTypeViewers[i].isValid())
                        s1 = "*" + s1;
                }
                catch(Exception exception)
                {
                    fHelper.getFeedback().error(exception);
                    s1 = "*" + s1;
                }
                tab.add(s1, component);
                if(fTypeViewers[i].getID().equals(fSelectedTypeViewID))
                    tab.setSelectedIndex(i);
            } else
            {
            	// new JPanel Creation to display string s
            	JComponent component = new JPanel();
            	JTextArea innerText = new JTextArea();
           
            	s  = s+ fTypeViewers[i].getID() + ":\n\t " + fTypeViewers[i].getSupportedItems() + "\n";
            	innerText.setBackground(new Color(255, 255, 225));
            	innerText.setOpaque(true);
            	innerText.setText(s);
            	
                GridBagLayout topLayout = new GridBagLayout();
                GridBagConstraints c = new GridBagConstraints();
                component.setLayout(topLayout);
                c.gridx = 0;
                c.gridy = 0;
                c.weightx = 1.0D;
                c.weighty = 1.0D;
                c.anchor=GridBagConstraints.NORTH;
                c.fill=1;
                component.add(new JScrollPane(innerText), c);
                s1= "NO DISPLAY FOR " + s1;
            	tab.add(s1,component);
             }
        }

        tab.addChangeListener(new ChangeListener() {

            public void stateChanged(ChangeEvent changeevent)
            {
                int j = tab.getSelectedIndex();
                if(j >= 0)
                    fSelectedTypeViewID = fTypeViewers[j].getID();
                else
                    fSelectedTypeViewID = null;
            }
           
        }
);
        fCenterPanel.removeAll();
        if(tab.getTabCount() == 0 && fXMLFile != null)
        {
            fCenterPanel.add(new JScrollPane(new JTextArea(s)));
    
        }
        else
            fCenterPanel.add(tab);
        fCenterPanel.validate();
     }
    
    private class RunnableReloadTypeViewer implements  Runnable {
   	 public void run()
     {
    	 fFileNameLabel.setText(fNameLabel + "(" + fTypeViewers.length + " typeviewers)");
         updateCenterContent();
      }
   	 private RunnableReloadTypeViewer()
   	 {
   		 super();
   	 }
 }

    
    
}
